
Sub Main(ByVal s() As String)
	ProvaSpirale
	'PiastriniOzonizzatore
End Sub


' =========================================================================
'   USER FUNCTIONS
' =========================================================================

' --------- MILL 500 ---------------
' X = 134 mm ( 125mm sicuri) 
' Y = 82 mm  ( 75 sicuri )  
' Z = 80 mm ( meno spessore e varie )

' --------- punte proxxon ----------
' diametro 0.8 mm oppure 0.6 mm
' parte cilindrica 3 mm
' angolo 120 gradi

'Sub ProvaSpirale()
'	SetFileName("Spirale.gc")
'	SetMaxValues(250, 60)
'	SetStock(40, 40, 6.7)
'	SetRapidFeed(250)
'	SetTool(3, 100)
'	Start()
'	' --------------------------------------------------------
'	SetFeed(100)
'	SetSpeed(20000)
'	RapidTo(2)
'	RapidTo(20, 20)
'	For a As Int32 = 0 To 360 Step 10
'		Dim rad As Double = a * (2 * PI) / 360
'		Debug.Print(rad.ToString)
'		MoveTo(10 * Sin(rad) + 20, 10 * Cos(rad) + 20, -8 * (a / 360))
'	Next
'	' --------------------------------------------------------
'	Finish()
'End Sub

Sub ProvaSpirale()
	SetFileName("Spirale.gc")
	SetMaxValues(250, 60)
	SetStock(40, 40, 6.7)
	SetRapidFeed(250)
	SetTool(3, 100)
	Start()
	' --------------------------------------------------------
	SetFeed(100)
	SetSpeed(20000)
	RapidTo(2)
	RapidTo(20, 20)
	For a As Int32 = 0 To 360 Step 10
		Dim rad As Double = a * (2 * PI) / 360
		Debug.Print(rad.ToString)		
		MoveTo(10 * Sin(rad) + 20, 10 * Cos(rad) + 20, -2)
	Next
	' --------------------------------------------------------
	Finish()
End Sub


Sub PiastriniOzonizzatore()
	Const Y1 As Double = 6      ' foro
	Const Y2 As Double = 20     ' inizio fessura
	Const Y3 As Double = 54     ' fine fessura

	Const X1 As Double = 8      ' primo  ( 8 ) ( 16 32 48 56 ... )
	Const X2 As Double = 158    ' ultimo ( 158 )
	Const Xstep As Double = 8   ' step   ( 8 )

	' ------------------------------------------------------------------ inizializzazione
	SetFileName("Piastrini.gc")
	SetMaxValues(250, 60)
	SetStock(160, 60, 6.7)
	SetRapidFeed(250)
	SetTool(0.8, 120)
	Start()
	' ------------------------------------------------------------------ inizio lavorazione
	SetSpeed(20000)
	'
	For x As Double = X1 To X2 Step Xstep

		' -------------------------------------------------------------- smusso del foro
		SetFeed(150)
		'
		RapidTo(2)              ' alza
		' 
		RapidTo(x, Y1)          ' vai a centro foro
		MoveTo(-0.3)            ' scendi a -0.3 e fai un cerchio
		'
		For a As Int32 = 0 To 360 Step 30
			Dim rad As Double = a * (2 * PI) / 360
			Debug.Print(rad.ToString)
			MoveTo(x + 0.3 * Sin(rad), Y1 + 0.3 * Cos(rad))
		Next


		' ------------------------------------------------------------- foro
		SetFeed(100)
		'
		RapidTo(x, Y1)          ' vai a centro foro
		' 
		MoveTo(-3)              ' scendi a -3


		' ------------------------------------------------------------- smussi della fessura
		SetFeed(250)
		'
		RapidTo(2)              ' alza
		RapidTo(x, Y2)          ' vai a centro fessura
		' 
		MoveTo(-0.3)            ' scendi a -.3 e fai un rettangolo
		MoveTo(x - 0.3, Y2)
		MoveTo(x - 0.3, Y3)
		MoveTo(x + 0.3, Y3)
		MoveTo(x + 0.3, Y2)
		' 
		MoveTo(-0.6)            ' scendi a -.6 e fai un rettangolo
		MoveTo(x - 0.15, Y2)
		MoveTo(x - 0.15, Y3)
		MoveTo(x + 0.15, Y3)
		MoveTo(x + 0.15, Y2)


		' ------------------------------------------------------------- fessura
		SetFeed(150)
		'
		RapidTo(x, Y2)          ' vai a centro fessura
		' 
		MoveTo(-1.35)           ' scendi di 0.75
		MoveTo(x, Y3)
		MoveTo(-2.1)            ' scendi di 0.75
		MoveTo(x, Y2)
		MoveTo(-2.85)           ' scendi di 0.75
		MoveTo(x, Y3)
		MoveTo(-3.6)            ' scendi di 0.75
		MoveTo(x, Y2)

	Next
	' ----------------------------------------------------------------- chiusura
	Finish()
End Sub








' =========================================================================
'   GCODE GENERATION
' =========================================================================


Dim CoordFormat As String = "0.000"

Dim FileName As String

Dim old_X As Double
Dim old_Y As Double
Dim old_Z As Double

Dim TotTime As Double
Dim TotMove As Double
Dim TotRapid As Double

Dim MaxFeedX As Double
Dim MaxFeedY As Double
Dim MaxFeedZ As Double

Dim RampX As Double
Dim RampY As Double
Dim RampZ As Double

Dim WorkFeed As Double
Dim WorkSpeed As Double
Dim RapidFeed As Double

Dim ToolDiam As Double
Dim ToolAngle As Double

Dim stock_dx As Double
Dim stock_dy As Double
Dim stock_dz As Double

Dim stock_ox As Double
Dim stock_oy As Double
Dim stock_oz As Double

Dim Gcode As List(Of String)

Private Function Dist(ByVal x1 As Double, ByVal x2 As Double, ByVal y1 As Double, ByVal y2 As Double, ByVal z1 As Double, ByVal z2 As Double) As Double
	Return Math.Sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2 + (z2 - z1) ^ 2)
End Function

Private Function Dist(ByVal x1 As Double, ByVal x2 As Double, ByVal y1 As Double, ByVal y2 As Double) As Double
	Return Math.Sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
End Function

Function CalcTime(ByVal delta As Double, ByVal feed As Double, ByVal ramp As Double) As Double
	Dim t As Double = (delta * 60.0) / feed
	If delta > 0 Then t += 0.42 * (feed / 60.0) / ramp
	Return t
End Function

Sub File_KillFile(ByRef FileName As String)
	On Error Resume Next
	If Not My.Computer.FileSystem.FileExists(FileName) Then Exit Sub
	SetAttr(FileName, FileAttribute.Normal)
	Kill(FileName)
End Sub

Function FormatNum(ByVal n As Double) As String
	Return n.ToString(CoordFormat).Replace(",", ".")
End Function

' ------------------------------------------------------------- PUBLIC

Sub Start()
	Gcode = New List(Of String)

	TotTime = 0
	TotMove = 0
	TotRapid = 0
	Gcode.Clear()
	Gcode.Add("")
	Gcode.Add("(MCUSTOCK X" & FormatNum(stock_dx) & _
					" Y" & FormatNum(stock_dy) & _
					" Z" & FormatNum(stock_dz) & _
					" OTL" & _
					" OX" & FormatNum(stock_ox) & _
					" OY" & FormatNum(stock_oy) & _
					" OZ" & FormatNum(stock_oz) & ")")
	Gcode.Add("")
	Gcode.Add("G21")
	Gcode.Add("G90")
	Gcode.Add("G40")
	Gcode.Add("M03")
	Gcode.Add("")
	Gcode.Add("(MCUTOOL T13 D" & FormatNum(ToolDiam) & " F3 L30 A" & FormatNum(ToolAngle))
	Gcode.Add("M06 T13")
	Gcode.Add("")
End Sub

Sub Finish()
	Gcode.Add("")
	Gcode.Add("(==============================)")
	Gcode.Add("( END OF PROGRAM               )")
	Gcode.Add("M05")
	Gcode.Add("G00 Z0.500")
	MoveTo(2)
	RapidTo(0, 0, 5)
	Gcode.Add("M30")
	Gcode.Add("M02")
	Gcode.Add("(==============================)")
	Gcode.Add("")
	Gcode.Add("(======= STATISTICS =======)")
	Gcode.Add("( Total Rapid " & TotRapid.ToString("0") & " mm")
	Gcode.Add("( Total Move " & TotMove.ToString("0") & " mm")
	Gcode.Add("")
	Gcode.Add("( Total estimated time:")
	'
	Dim h As Integer = CInt(Floor(TotTime / 3600))
	TotTime -= h * 3600
	Dim m As Integer = CInt(Floor(TotTime / 60.0))
	TotTime -= m * 60
	Dim sec As Integer = CInt(TotTime)
	'
	If h > 0 Then Gcode.Add("( " & h.ToString & " hours")
	If m > 0 Then Gcode.Add("( " & m.ToString & " min.")
	Gcode.Add("( " & sec.ToString & " sec.")
	Gcode.Add("")
	'
	Dim f As String = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) & "\" & FileName

	File_KillFile(f)
	Dim file As IO.StreamWriter = My.Computer.FileSystem.OpenTextFileWriter(f, False, System.Text.Encoding.ASCII)
	For Each s As String In Gcode
		file.WriteLine(s & vbCr)
	Next
	file.Close()

	Process.Start(f)
End Sub


Sub SetFileName(ByVal _FileName As String)
	FileName = _FileName
End Sub

Sub SetMaxValues(ByVal MaxFeed As Double, ByVal Ramp As Double)
	MaxFeedX = MaxFeed
	MaxFeedY = MaxFeed
	MaxFeedZ = MaxFeed
	RampX = Ramp
	RampY = Ramp
	RampZ = Ramp
End Sub

Sub SetStock(ByVal x As Double, ByVal y As Double, ByVal z As Double)
	stock_dx = x
	stock_dy = y
	stock_dz = z
End Sub

Sub SetRapidFeed(ByVal _RapidFeed As Double)
	RapidFeed = _RapidFeed
End Sub

Sub SetFeed(ByVal _WorkFeed As Double)
	WorkFeed = _WorkFeed
	Gcode.Add("F " & WorkFeed.ToString)
End Sub

Sub SetSpeed(ByVal _WorkSpeed As Double)
	WorkSpeed = _WorkSpeed
	Gcode.Add("S " & WorkSpeed.ToString)
End Sub

Sub SetTool(ByVal _ToolDiam As Double, ByVal _ToolAngle As Double)
	ToolDiam = _ToolDiam
	ToolAngle = _ToolAngle
End Sub




Friend Sub RapidTo(ByVal x As Double, ByVal y As Double, ByVal z As Double)
		If x <> old_X Or y <> old_Y Or z <> old_Z Then
			'
			Dim delta As Double
			'
			If Abs(z - old_Z) > Abs(x - old_X) And Abs(z - old_Z) > Abs(y - old_Y) Then
				delta = Abs(z - old_Z)
				TotTime += CalcTime(delta, MaxFeedZ, RampZ)
			Else
				If Abs(x - old_X) > Abs(y - old_Y) Then
					delta = Abs(x - old_X)
					TotTime += CalcTime(delta, MaxFeedX, RampX)
				Else
					delta = Abs(y - old_Y)
					TotTime += CalcTime(delta, MaxFeedY, RampY)
				End If
			End If
			'
			'TotRapid += delta
			TotRapid += Dist(x, old_X, y, old_Y, z, old_Z)
			'
			old_X = x
			old_Y = y
			old_Z = z
			'
			Gcode.Add("G00 X" & FormatNum(x) & " Y" & FormatNum(y) & " Z" & FormatNum(z))
		End If
	End Sub

	Friend Sub RapidTo(ByVal x As Double, ByVal y As Double)
		If x <> old_X Or y <> old_Y Then
			'
			Dim delta As Double
			'
			If Abs(x - old_X) > Abs(y - old_Y) Then
				delta = Abs(x - old_X)
				TotTime += CalcTime(delta, MaxFeedX, RampX)
			Else
				delta = Abs(y - old_Y)
				TotTime += CalcTime(delta, MaxFeedY, RampY)
			End If
			'
			'TotRapid += delta
			TotRapid += Dist(x, old_X, y, old_Y)
			'
			old_X = x
			old_Y = y
			'
			Gcode.Add("G00 X" & FormatNum(x) & " Y" & FormatNum(y))
		End If
	End Sub

	Friend Sub RapidTo(ByVal z As Double)
		'
		Dim delta As Double
		'
		If z <> old_Z Then
			delta = Abs(z - old_Z)
			TotTime += CalcTime(delta, MaxFeedZ, RampZ)
			TotRapid += delta
			'
			old_Z = z
			'
			Gcode.Add("G00 Z" & FormatNum(z))
		End If
	End Sub


	Friend Sub MoveTo(ByVal x As Double, ByVal y As Double, ByVal z As Double)
		If x <> old_X Or y <> old_Y Or z <> old_Z Then
			'
			Dim delta As Double
			'
			If Abs(z - old_Z) > Abs(x - old_X) And Abs(z - old_Z) > Abs(y - old_Y) Then
				delta = Abs(z - old_Z)
				TotTime += CalcTime(delta, MaxFeedZ, RampZ)
			Else
				If Abs(x - old_X) > Abs(y - old_Y) Then
					delta = Abs(x - old_X)
					TotTime += CalcTime(delta, WorkFeed, RampX)
				Else
					delta = Abs(y - old_Y)
					TotTime += CalcTime(delta, WorkFeed, RampY)
				End If
			End If
			'
			'TotMove += delta
			TotMove += Dist(x, old_X, y, old_Y, z, old_Z)
			'
			old_X = x
			old_Y = y
			old_Z = z
			'
			Gcode.Add("G01 X" & FormatNum(x) & " Y" & FormatNum(y) & " Z" & FormatNum(z))
		End If
	End Sub

	Friend Sub MoveTo(ByVal x As Double, ByVal y As Double)
		If x <> old_X Or y <> old_Y Then
			'
			Dim delta As Double
			'
			If Abs(x - old_X) > Abs(y - old_Y) Then
				delta = Abs(x - old_X)
				TotTime += CalcTime(delta, WorkFeed, RampX)
			Else
				delta = Abs(y - old_Y)
				TotTime += CalcTime(delta, WorkFeed, RampY)
			End If
			'
			'TotMove += delta
			TotMove += Dist(x, old_X, y, old_Y)
			'
			old_X = x
			old_Y = y
			'
			Gcode.Add("G01 X" & FormatNum(x) & " Y" & FormatNum(y))
		End If
	End Sub

	Friend Sub MoveTo(ByVal z As Double)
		'
		Dim delta As Double
		'
		If z <> old_Z Then
			delta = Abs(z - old_Z)
			TotTime += CalcTime(delta, WorkFeed, RampZ)
			TotRapid += delta
			'
			old_Z = z
			'
			Gcode.Add("G01 Z" & FormatNum(z))
		End If
	End Sub

