
Sub Main(ByVal args As String())
	'if args.length > 0 then
	'	Select Case args(0)
	'		Case "1": Method1
	'		Case "2": Method2
	'		Case "3": Method3
	'		Case "4": Method4
	'	End Select
	'else
	'	MsgBox("This example requires Host.PictureBox and Host.TextBox")
	'end if
	
	Method1
End Sub


Sub Method1()
	InitPictureboxImage
	Timer1.interval = 20
	If timer1.enabled Then
		timer1.enabled = False
		Timer1.Stop
	Else
		timer1.enabled = True
		Timer1.start
	End If
End Sub	

Sub Method2()
	InitPictureboxImage
	TestLines
End Sub

Sub Method3()
	GetTextBox.text &= "Test" & GetText() & vbcrlf
	'MessageBox.Show("HELLO WORLD")
End Sub

Sub Method4()
	host.showmessage("GOODBYE")
End Sub



' ------------------------------------------------------
'	Common functions
' ------------------------------------------------------
Sub InitPictureboxImage
	With GetPictureBox
		If .ClientSize.Height < 1 Then Return
		.sizemode = PictureBoxSizeMode.Normal
		If .image Is Nothing Then .Image = New Bitmap(.ClientSize.Width, .ClientSize.Height)
	End With
End Sub

Sub ClearPicturebox
	Dim g As Graphics = Graphics.FromImage(GetPictureBox.Image)
	g.clear(color.white)
End Sub

Function GetText() As String
	Static n As Int32
	n += 1
	Return n.tostring
End Function

'Function RandomColor() as Color
'	return color.fromargb( 255 - rnd * 30, _
'						255 - rnd * 30, _
'						255 - rnd * 30)
'End Function
'
'Function RandomDarkColor() as Color
'	return color.fromargb( 255 - rnd * 200, _
'						255 - rnd * 200, _
'						255 - rnd * 200)
'End Function


WithEvents Timer1 As System.Windows.Forms.Timer = New System.Windows.Forms.Timer

Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
	'
	Test_Circles
End Sub



' ------------------------------------------------------
'	Test Lines
' ------------------------------------------------------

Private TestLinesWorking As Boolean = False
Private TestLinesAbort As Boolean = False
Sub TestLines()
	If TestLinesWorking Then
		TestLinesAbort = True
		Exit Sub
	End If 

	TestLinesAbort = False
	TestLinesWorking = True

	Dim div As Double
	Dim x1 As Double
	Dim y1 As Double
	Dim x2 As Double
	Dim y2 As Double
	Dim x3 As Double
	Dim y3 As Double
	Dim x4 As Double
	Dim y4 As Double
	Dim dx1 As Double
	Dim dx2 As Double
	Dim dy1 As Double
	Dim dy2 As Double
	Dim f As Double

	Dim w As Long = GetPictureBox.width
	Dim h As Long = GetPictureBox.Height

	Dim g As Graphics = Graphics.FromImage(GetPictureBox.Image)

	div = 64
	Do
		Dim p As pen = New pen(color.fromargb(CInt(rnd*255),CInt(rnd*255), CInt(rnd*255)))

		dx1 = w * Rnd: dy1 = h * Rnd
		dx2 = w * Rnd: dy2 = h * Rnd
		x3 = ((dx1 - x1) / div): y3 = ((dy1 - y1) / div)
		x4 = ((dx2 - x2) / div): y4 = ((dy2 - y2) / div)
		For f = 1 To 80
			x1 = x1 + x3: y1 = y1 + y3
			x2 = x2 + x4: y2 = y2 + y4
			g.drawLine (p, CInt(x1), CInt(y1), CInt(x2), CInt(y2))
		Next
		GetPictureBox.refresh
		application.doevents
	Loop Until TestLinesAbort

	TestLinesWorking = False
End Sub




' ------------------------------------------------------
'	Test Circles
' ------------------------------------------------------

Private Sub Test_Circles()
	'on error resume next

	Dim g As Graphics = Graphics.FromImage(GetPictureBox.Image)

	Dim r As Int32
	Dim x As Int32
	Dim y As Int32
	Dim b As SolidBrush
	Dim cr As Int32
	Dim cg As Int32
	Dim cb As Int32

	For i As Int32 = 1 To 40
		r = CInt(20 + 40 * Rnd())
		x = CInt(250 * Rnd())
		y = CInt(210 * Rnd())
		cr = CInt(50 + 70 * Rnd())
		cg = CInt(50 + 70 * Rnd())
		cb = CInt(50 + 70 * Rnd())

		For r2 As Int32 = r To 1 Step -1
			b = New SolidBrush(Color.FromArgb(cr, cg, cb))
			g.FillEllipse(b, x - r2 \ 3, y - r2 \ 3, r2, r2)
			cr = min(cr + 5, 255)
			cg = min(cg + 4, 255)
			cb = min(cb + 4, 255)
		Next
	Next

	GetPictureBox.refresh
End Sub

