' ================================================================================================
' - ENGLISH - JUMBO COUNTER
' ================================================================================================
'  This script reads slot1 and shows its value with a large display.
' ------------------------------------------------------------------------------------------------

' ================================================================================================
' - ITALIANO - JUMBO COUNTER
' ================================================================================================
'  Questo script legge lo slot1 e presenta il suo valore in un grande display.
' ------------------------------------------------------------------------------------------------

Dim ProgramName As String = "JUMBO COUNTER"
Dim OldValue As Single
Dim gvGeigerValue As Single

Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New Form
	InitializeComponents
	MemoryMappedFile_Init
	OldValue = ReadSlot(1)
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	Timer1.Stop
End Sub

Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	Dim Value As Single = ReadSlot(1)
	gvGeigerValue += Value - OldValue
	OldValue = Value
	Label1.Text = gvGeigerValue.ToString 
End Sub

Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click
	gvGeigerValue= 0
End Sub


' ---------------------------------------------------------------------- User Interface Components
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim Label1 As Label = New Label
Dim WithEvents ButtonReset As System.Windows.Forms.Button = New System.Windows.Forms.Button

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - " & ProgramName
	Form1.FormBorderStyle = FormBorderStyle.Fixed3D
	Form1.ClientSize = New System.Drawing.Size(640, 280)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ ButtonReset
	ButtonReset.Location = New Point(0, 0)
	ButtonReset.Size = New Size(54, 23)
	ButtonReset.Text = "Reset"
	ButtonReset.UseVisualStyleBackColor = True
	Form1.Controls.Add(ButtonReset)
	' ------------------------------------------------------------------ Label 1
	'Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(0, 0)
	Label1.Size = Form1.ClientSize
	Label1.BackColor = Color.DarkBlue
	Label1.ForeColor = Color.Gold
	Label1.Font = New Font("Tahoma", 180, FontStyle.Bold)
	Label1.TextAlign = ContentAlignment.MiddleRight
	Label1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or _
					AnchorStyles.Right Or AnchorStyles.Bottom
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 50
	Timer1.Start
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub

